function ImDiff()
close all

global YUV

% [GetImage] liest ein beliebiges Bild ein
% grauwertige Bilder: A enthaelt die Grauwerte
% farbige Bilder    : A enthaelt die Helligkeitswerte des Bildes
%                       nur darauf wird gearbeitet.
% [PutImage] speichert eine Bilddatei, die wieder alle Farben enthaelt wenn
% es sich urspruenglich um ein Farbbild handelte :)
A = GetImage('xmas.jpg');
% [imshow] Zeigt das Bild in einem Fenster figure(1)
%imshow(A);
% [plotImg] plottet das Bild als Graph im R3
%plotImg(A);

%--------------------------------------------------------------------
% <workarea>

A = 1-A;      

%G = CanyEdge(A,0.1);
%A = DiffusionIso(A,1,-0.1);

%figure(2);
%imshow(A);
%plotImg(A);

% </workarea>
%--------------------------------------------------------------------
PutImage(A,'xmas2.jpg');

end


function C=CanyEdge(A,beta)
[M N] = size(A);

for i=1:M
    for j=1:N
        Ax = (A(i,min(N,j+1))-A(i,max(1,j-1)))/2;
        Ay = (A(min(M,i+1),j)-A(max(1,i-1),j))/2;
        BetragGradient = sqrt(Ax^2+Ay^2);
        
        C(i,j) = beta/sqrt(beta^2+BetragGradient^2);   
    end
end
end


function A=DiffusionIso(A,LOOPmax,delta)
[M N] = size(A);

for LOOP=1:LOOPmax
for i=1:M
    for j=1:N
        Axx = A(i,min(N,j+1))-2*A(i,j)+A(i,max(1,j-1));
        Ayy = A(min(M,i+1),j)-2*A(i,j)+A(max(1,i-1),j);
        LaplaceA = Axx+Ayy;
        
        A(i,j) = A(i,j)+delta*LaplaceA;   
    end
end
end

end

function plotImg(A)
[M N] = size(A);

Ix  = [1 N];
Iy  = [1 M];
DIM = [N M];
hx  = (Ix(2)-Ix(1))/(DIM(1)-1);
hy  = (Iy(2)-Iy(1))/(DIM(2)-1);

[x1, x2] = meshgrid(Ix(1):hx:Ix(2),Iy(1):hy:Iy(2));

surf(x1,x2,A,'LineStyle','none');
colormap(gray);

end


function A=GetImage(ImName)

global YUV

Ai = imread(ImName);
Af  = im2double(Ai);

if length(size(Af))==3
    YUV=RGB2YUV(Af);
    A = YUV(:,:,1);
else
    YUV = 0;
    A = Af;
end

end

function PutImage(A,ImName)

global YUV

if size(YUV)>1
    YUV(:,:,1) = A;
    A = YUV2RGB(YUV);
end

Ai = im2uint8(A);
imwrite(Ai,ImName);


end

function Ayuv=RGB2YUV(Argb)

R=Argb(:,:,1);
G=Argb(:,:,2);
B=Argb(:,:,3);

Y = 0.299 * R + 0.587 * G + 0.114 * B;
U = -0.14713 * R - 0.28886 * G + 0.436 * B;
V = 0.615 * R - 0.51499 * G - 0.10001 * B;
Ayuv = cat(3,Y,U,V);

end

function Argb=YUV2RGB(Ayuv)

Y=Ayuv(:,:,1);
U=Ayuv(:,:,2);
V=Ayuv(:,:,3);

R = Y + 1.139834576 * V;
G = Y -.3946460533 * U -.58060 * V;
B = Y + 2.032111938 * U;

Argb = cat(3,R,G,B);

end

